'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _csvString = require('csv-string');

var _csvString2 = _interopRequireDefault(_csvString);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function CSVParse(data, feed) {
    var separator = this.getParam('separator');
    var quote = this.getParam('quote');
    if (!this.handle) {
        this.handle = _csvString2.default.createStream({ separator: separator, quote: quote });
        this.handle.on('data', function (obj) {
            return feed.write(obj);
        });
    }
    if (!this.isLast()) {
        (0, _utils.writeTo)(this.handle, data, function () {
            return feed.end();
        });
    } else {
        this.handle.end(function () {
            return feed.close();
        });
    }
}

/**
 * Take `String` and parse CSV  to generate object
 *
 * @name CSVParse
 * @param {String} [separator=auto] to indicate the CSV separator
 * @param {String} [quote=auto] to indicate the CSV quote.
 * @returns {Object}
 * @see https://github.com/Inist-CNRS/node-csv-string
 */
exports.default = {
    CSVParse: CSVParse
};