'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _JSONStream = require('JSONStream');

var _JSONStream2 = _interopRequireDefault(_JSONStream);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function JSONParse(data, feed) {
    if (!this.handle) {
        var separator = this.getParam('separator', '*');
        this.handle = _JSONStream2.default.parse(separator);
        this.handle.on('data', function (obj) {
            return feed.write(obj);
        });
    }
    if (!this.isLast()) {
        (0, _utils.writeTo)(this.handle, data, function () {
            return feed.end();
        });
    } else {
        this.handle.end();
        process.nextTick(function () {
            feed.close();
        });
    }
}

/**
 * Take `String` and parse JSON and generate objects
 *
 * @name JSONParse
 * @param {String} [separator=*] to split at every JSONPath found
 * @returns {Object}
 * @see https://github.com/dominictarr/JSONStream
 */
exports.default = {
    JSONParse: JSONParse
};