'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _flat = require('flat');

var _flat2 = _interopRequireDefault(_flat);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function OBJFlatten(data, feed) {
    var opts = {
        delimiter: this.getParam('separator', '/'),
        safe: this.getParam('safe', true)
    };
    if (this.isLast()) {
        feed.close();
    } else {
        feed.send((0, _flat2.default)(data, opts));
    }
}

/**
 * Take `Object` and flat it with delimited character.
 *
 * @name OBJFlatten
 * @alias flatten
 * @param {String} [separator=/] choose a character for  flatten keys
 * @param {Boolean} [safe=false] preserve arrays and their contents,
 * @returns {Object}
 * @see https://www.npmjs.com/package/flat
 */
exports.default = {
    OBJFlatten: OBJFlatten
};