'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _zlib = require('zlib');

var _zlib2 = _interopRequireDefault(_zlib);

var _stream = require('stream');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function TXTZip(data, feed) {
    if (this.isFirst()) {
        this.input = new _stream.PassThrough();
        this.gzip = _zlib2.default.createGzip();
        var output = this.input.pipe(this.gzip);
        output.on('data', function (d) {
            return feed.write(d);
        });
        output.on('end', function () {
            return feed.close();
        });
        output.on('error', function (e) {
            return feed.stop(e);
        });
    }

    if (this.isLast()) {
        return this.input.end();
    }

    if (!this.input.write(data)) {
        this.input.once('drain', function () {
            return feed.end();
        });
    } else {
        feed.end();
    }
}

/**
 * Take a String and zip it
 *
 * @name TXTZip
 * @returns {Buffer}
 */
exports.default = {
    TXTZip: TXTZip
};