'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _fetchWithProxy = require('fetch-with-proxy');

var _fetchWithProxy2 = _interopRequireDefault(_fetchWithProxy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function URLFetch(data, feed) {
    var url = this.getParam('url');
    var target = this.getParam('target');
    var json = this.getParam('json', false);

    if (this.isLast() || !url) {
        return feed.send(data);
    }
    (0, _fetchWithProxy2.default)(url).then(function (response) {
        if (response.status !== 200) {
            var msg = 'Received status code ' + response.statusCode + ' (' + response.statusMessage + ')\'';
            throw new Error(msg);
        }
        return json ? response.json() : response.text();
    }).then(function (body) {
        if (target && typeof target === 'string' && (typeof data === 'undefined' ? 'undefined' : _typeof(data)) === 'object') {
            data[target] = body;
            return feed.send(data);
        }
        return feed.send(body);
    }).catch(function (error) {
        return feed.send(error);
    });
}

/**
 * Take `Object` and create a new field with the content of URL.
 * Or if no target will be specified, the output will be the content of URL
 *
 * @name URLFetch
 * @param {String} [url] URL to fecth
 * @param {String} [target] choose the key to set
 * @param {String} [json=false] Pasre as JSON the content of URL
 * @returns {Object}
 */
exports.default = {
    URLFetch: URLFetch
};