'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _xmlSplitter = require('xml-splitter');

var _xmlSplitter2 = _interopRequireDefault(_xmlSplitter);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function XMLParse(data, feed) {
    if (!this.handle) {
        var separator = this.getParam('separator', '/');
        this.handle = new _xmlSplitter2.default(separator);
        this.handle.on('data', function (obj) {
            return feed.write(obj);
        });
    }
    if (!this.isLast()) {
        (0, _utils.writeTo)(this.handle.stream, data, function () {
            return feed.end();
        });
    } else {
        this.handle.stream.end();
        process.nextTick(function () {
            feed.close();
        });
        /*
         this.handle.stream has be created by sax@0.5,
         and I cannot handle the "end" event (and I don't know why)
         so I use nextTrick instead of end().
         It's badly, but it's works in many cases
         */
    }
}

/**
 * Take `String` as XML input, parse it and split it in multi document at each path found
 *
 * @name XMLParse
 * @param {String} [url] URL to fecth
 * @param {String} [target] choose the key to set
 * @param {String} [separator=/] choose a character for flatten keys
 * @returns {Object}
 * @see https://www.npmjs.com/package/xml-splitter
 */
exports.default = {
    XMLParse: XMLParse
};