'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _xmlMapping = require('xml-mapping');

var _xmlMapping2 = _interopRequireDefault(_xmlMapping);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function XMLString(data, feed) {
    var rootElement = this.getParam('rootElement', 'items');
    var contentElement = this.getParam('contentElement', 'item');
    var beginTag = rootElement ? '<' + rootElement + '>' : '';
    var endTag = rootElement ? '</' + rootElement + '>' : '';

    if (this.isLast()) {
        if (endTag) feed.write(endTag);
        return feed.close();
    }
    if (this.isFirst() && beginTag) {
        feed.write(beginTag);
    }
    feed.send(_xmlMapping2.default.dump(_defineProperty({}, contentElement, data)));
}

/**
 * Take `Object` and transform it into a XML string
 *
 * @name XMLString
 * @param {String} [rootElement=items] Root element name for the tag which start and close the feed
 * @param {String} [contentElement=item] Content element name for the tag which start and close each item
 * @returns {String}
 */
exports.default = {
    XMLString: XMLString
};